CĿ
C     Name: RaPIVe                                           11.05.97 12:30pm 
C                                                                             
C     Description: Found N1 positions of minimums in vector V                 
C                  in interval [1,N2] and save them in IV                     
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  RaPIVe ( N1, NN,NV, V,IV )  ! N1 < N2
      real*8      V ( NN ), Vmin
      integer*2   IV( NV ), I, J, II, Nmin
      automatic

C-----------------------------------------------------------------------------
C     N1 - length for IV
C     N2 - interval in V
C-----------------------------------------------------------------------------
	
	do 10 II= 1,N1
	Vmin = 1.E300

!	   I = minloc( V, dim=1, MASK = V.GT.Vmin )   ! Found position of global CRmin
	
		do 20 I= 1,NN
            if( V( I ) < Vmin  ) then

                  do 30 J= 1,II-1
30                if( IV( J ) .eq. I ) goto 20 ! Minimum was founded previosly?

               Vmin = V( I )
               Nmin = I                         ! Save tmp min
            endif
20       continue

!10       IV( J ) = Nmin                         ! Write min

10	   IV( II ) = Nmin
!10	   Vmin = V( I )

      return
      end
