CĿ
C     Name: DelayArg                                         06/18/93 05:12pm 
C                                                                             
C     Description: Create delayed variables array                                          
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      subroutine      DelayArg ( M0,ML,M,MY,N, X, Im,RMin )
      real            X  ( ML,N )
      integer*2       Im ( 600 )
      real            RMin( ML )
      common /LMai1/  JRes,  JFile,  JGraph,  JNorm,  JProt,  LFor,
     +                LAn,   LTest,   LSel
      common /LMai2/  JFun,    JS,   JRegul,   ISe,  ICr, JDiv
      automatic
C=============================================================================
C        MM,NN,MMY - real number of need columns, founded from Im,In,Iy in CardIn
C        M, N, MY  - declared size values for reading from file
C=============================================================================
      LFor11  = LFor - 1                        ! Steps up

      do 70 J= 1,ML
70       RMin( J ) = Im( J )                    ! Save Im in tmp RMin 
C**********************************************************************
C        Functions
C**********************************************************************
      do 20 J= MY,1,-1
         do 10 I= 1,N-1
10       X( M+J,I ) = X( M0+J,I+1 )              ! Move functions right
20     Im ( M+J ) = Im( M0+J )                   ! Write their names

C**********************************************************************
C        Variables
C**********************************************************************
      if( JFun == 0 ) then                      ! How many functions are used
         L = M0 + MY                              ! Calculate number of delayed columns
      else
		L = M0
!         L = M0 + 1
!	   RMin( L ) = RMin( M0+MY )                ! Move last function after last variable
!	      do 90 I=1,N
!90          X(L,I) = X(M0+MY,I)
      endif

      JJ = L   
	do 80 II= 1,LFor11
	   do 80 J= 1,L
            JJ = JJ + 1
            do 80 I= 1,N-II
80	         X(JJ,I+II)= X(J,I)                 ! Create delayed vars with functions

      do 30 J= 1,ML
         X(J,N) = 0.                              ! Set last points to 0
         do 30 I= 1,N-LFor11
30          X( J,I ) = X( J,I+LFor11 )            ! Move up full array

      JJ = 0
      do 50 II= 1,LFor
	   do 50 J= 1,L
	   JJ = JJ + 1
         if( RMin( J ) .ge. 0) then
            Im( JJ ) = RMin( J )*100 + II         ! Write new variable names [301]
         else
	      Im( JJ ) = RMin( J )*100 - II         ! Write new function names [-301]
50       endif

      N  = N - LFor                               ! Decrease points number
      if( N .le. 3 ) then
         write (*,*)
     +'*** Abort: Sorry, too many delayed variables or few points !***'
         stop
      endif

      return
      end
