CĿ
C     Name: Deviat                                           06.05.97 15:47pm 
C                                                                             
C     Description: Divide points into subsamples                              
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Deviat ( LCh, ML,ML11,ML1,N, X, CO, Vn,In )
      real        X( ML,N )
      real*8      CO ( ML1 ),  Vn( N )
      integer*2   In( N )
C      automatic
C
C        Calculate vector of average values and minimize deviations from it
C
      do 10 J= 1,ML11
         CO( J ) = 0.
         do 10 I= 1,N
10          CO( J ) = CO( J ) + X( J,I )         ! Use CO as tmp vector

      do 20 J= 1,ML11
20    CO( J ) = CO( J ) / N                      ! Calculate average values

      do 30 I= 1,N
         Vn( I ) = 0.
            do 30 J= 1,ML11                      ! Calculate dispersion
30          Vn( I ) = Vn( I ) + ( CO( J ) - X( J,I ))**2

      call RaMinVe2 ( 1, N, Vn, In )             ! Range points according to dispersion

C      if( JPr .ge. 4 )  then
C         write (*,*) 'Dispersion  Vn :'
C         call VePri  ( N, N, Vn )
C         write (*,*) 'Points no. In :'
C         call Vi2Pri ( N, N, In )
C     write(*,*)
C      endif

      LCh = 0                                     ! Selection of every third point
      do 50 I= 3,N,3                              ! from set to test subsample
         LCh = LCh + 1
         Vn( LCh ) = In( I )                      ! Save test points
50       In( I )   = 32001                        ! Delete them

      call RaVeI2 ( N,N,In )                      ! Range training set
C      write (*,*) N-LCh,'Train:', 'In:',( In( I ), I=1,N-LCh )
C      write (*,*) LCh,'Test:', 'Vn:',( Vn( I ), I=1,Lch )
                                            ! ranging of test set is not needed
      J = N
      do 60 I= 1,LCh
         In( J ) = Vn( I )
60       J = J - 1                           ! write test at the end

C      write (*,*) 'All points divided:', 'In:',( In( I ), I=1,N )
      return
      end
