C = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
C
C  ᫥ ᮡ⢥ 祭  ᮡ⢥ ஢  
C  c筮 ⭮   A  ࠧ  n x n
C
C  a   - 室  (ᨬ筠) ࠧ蠥  -
C         ᫥. ᫥ ᮡ⢥ 祭
C        ᯮ       A   浪 
C        ⠭.   㣮쭠    A 
C        ᠭ  ⮫栬  ᨢ  a.
C  r   - ᫥  ᮡ⢥ ஢ (࠭
C         ⮩   ᫥⥫쭮,      ᮡ⢥ 
C        祭).
C  n   - 冷   A    R
C  mv  -  ᫥
C        mv  = 0   ===>    ᮡ⢥ 祭 
C                         ᮡ⢥ 
C        mv  = 1   ===>    ⮫쪮 ᮡ⢥
C                         祭  
C        ipr - 㪠⥫  
C              ipr = 0  ===>   
C              ipr = 1  ===>   १
C              ipr = 2  ===>   室 
C                              १
C
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
	SUBROUTINE eigen(a,r,n,mv,ipr)
        IMPLICIT REAL*8(a-h,o-z)
	DIMENSION a(1),r(1)
        IF(ipr.NE.0) PRINT 600
  600   FORMAT(//1X,25('-'),3X,'/ EIGEN',3X,25('-')//)
        IF(ipr.NE.2) GOTO 5
        PRINT 200,n,n
 200    FORMAT(//1X,'᫥ ᮡ⢥ 祭  ',
     *              '஢',
     *          /1X,'ᨬ筮  ',I2,' x ',I2,
     *              ' - '//)
        DO 201 j=1,n
        PRINT 202,j
 202    FORMAT(5X,'        ',I2)
        k =(j-1)*j/2
        PRINT 203,(a(k+i),i=1,j)
 203    FORMAT(5(2X,1P1E12.5))
        PRINT 204
 204    FORMAT(/)
 201    CONTINUE
   5    range = 1.D-14
        IF(mv-1) 10,25,10
  10    iq    =-n
        DO 20 j=1,n
        iq    = iq+n
        DO 20 i=1,n
        ij    = iq+i
        r(ij) = 0.D0
        IF(i-j) 20,15,20
  15    r(ij) = 1.D0
  20    CONTINUE
  25    anorm = 0.D0
        DO 35 i=1,n
        DO 35 j=i,n
        IF(i-j) 30,35,30
  30    ia    = i+j*(j-1)/2
        anorm = anorm+a(ia)*a(ia)
  35    CONTINUE
        IF(anorm) 165,165,40
  40    anorm = DSQRT(2.D0*anorm)
        anrmx = anorm*range/DFLOAT(n)
        ind   = 0
        thr   = anorm
  45    thr   = thr/DFLOAT(n)
  50    l     = 1
  55    m     = l+1
  60    mq    = m*(m-1)/2
        lq    = l*(l-1)/2
        lm    = l+mq
  62    IF(DABS(a(lm))-thr) 130,65,65
  65    ind   = 1
        ll    = l+lq
        mm    = m+mq
        x     = (a(ll)-a(mm))*5.D-1
  68    y     =-a(lm)/DSQRT(a(lm)*a(lm)+x*x)
        IF(x) 70,75,75
  70    y     =-y
  75    sinx  = y/DSQRT(2.D0*(1.0+DSQRT(1.D0-y*y)))
        sinx2 = sinx*sinx
  78    cosx  = DSQRT(1.D0-sinx2)
        cosx2 = cosx*cosx
        sincs = sinx*cosx
        ilq   = n*(l-1)
        imq   = n*(m-1)
        DO 125 i=1,n
        iq    = i*(i-1)/2
        IF(i-l) 80,115,80
  80    IF(i-m) 85,115,90
  85    im    = i+mq
        GOTO 95
  90    im    = m+iq
  95    IF(i-l) 100,105,105
 100    il    = i+lq
        GOTO 110
 105    il    = l+iq
 110    x     = a(il)*cosx-a(im)*sinx
        a(im) = a(il)*sinx+a(im)*cosx
        a(il) = x
 115    IF(mv-1) 120,125,120
 120    ilr   = ilq+i
        imr   = imq+i
        x     = r(ilr)*cosx-r(imr)*sinx
        r(imr)= r(ilr)*sinx+r(imr)*cosx
        r(ilr)= x
 125    CONTINUE
        x     = 2.D0*a(lm)*sincs
        y     = a(ll)*cosx2+a(mm)*sinx2-x
        x     = a(ll)*sinx2+a(mm)*cosx2+x
        a(lm) = (a(ll)-a(mm))*sincs+a(lm)*
     *          (cosx2-sinx2)
        a(ll) = y
        a(mm) = x
 130    IF(m-n) 135,140,135
 135    m     = m+1
        GOTO 60
 140    IF(l-(n-1)) 145,150,145
 145    l     = l+1
        GOTO 55
 150    IF(ind-1) 160,155,160
 155    ind   = 0
        GOTO 50
 160    IF(thr-anrmx) 165,165,45
 165    iq    =-n
        DO 185 i=1,n
        iq    = iq+n
        ll    = i+i*(i-1)/2
        jq    = n*(i-2)
        DO 185 j=i,n
        jq    = jq+n
        mm    = j+j*(j-1)/2
        IF(a(ll)-a(mm)) 170,185,185
 170    x     = a(ll)
        a(ll) = a(mm)
        a(mm) = x
        IF(mv-1) 175,185,175
 175    DO 180 k=1,n
        ilr   = iq+k
        imr   = jq+k
        x     = r(ilr)
        r(ilr)= r(imr)
 180    r(imr)= x
 185    CONTINUE
        IF(ipr.EQ.0) RETURN
        PRINT 300
 300    FORMAT(//)
        DO 301 j=1,n
        k  =(j+1)*j/2
        PRINT 302,j,a(k)
 302    FORMAT(1X,I2,'-  ᮡ⢥ 祭',2X,1P1E12.5)
        IF(mv.EQ.1) GOTO 301
        PRINT 303,j
 303    FORMAT(1X,I2,'-  ᮡ⢥ ')
        k =(j-1)*n
        PRINT 203,(r(k+i),i=1,n)
        PRINT 204
 301    CONTINUE  
        RETURN
	END