c*********************************************************************
C    HARMONICAL INDUCTIVE LEARNING ALGORITHM
C
C
C     N - NO.OF TRAINING SET POINTS
C     NP - NO.OF TEST SET POINTS
C     NE - NO.OF EXAMIN SET POINTS
C     PT - NO.OF PREDICTION POINTS
C     JFM - MAX NO.OF FREQUENCIES
C     JF - FREEDOM OF CHOICE
C     NRM - NO.OF SERIES IN HARMONICAL TREND
C     NN = N+NP+NE
C     NPT = NN+PT
C     G(NN) - DISCRETE SIGNAL DATA
C     APR(NPT) - HARMONICAL MODEL VALUES
C     MA - NO.OF LAG POINTS FOR SMOOTHING PROCEDURE(MOVING AVERAGE
C          VALUE). IF IT IS ONE, DATA REMAINS SAME
C
C*********************************************************************
C      MAIN PROGRAM
C
       INTEGER PT
       DIMENSION GY(120)
       COMMON /AB/ G(120)
       OPEN(3,FILE='output.dat') 
	 OPEN(8,FILE='ts.dat', status='unknown', mode='read')
       WRITE(3,4)
4      FORMAT(5X,' LAYERED    HARMONICAL ALGORITHM'/)
       WRITE(*,110) 
110    FORMAT(3X,'GIVE NO.OF TRAIN, TEST & EXAM PTS?')

C       READ(*,*)N,NP,NE
	N=45
	NP=1
	NE=1
       NN=N+NP+NE
       WRITE(*,112)
112    FORMAT(3X,'GIVE NO.OF PRED PTS??')

C       READ(*,*)PT
	PT=5
       NPT=NN+PT

	 do 10 I=1,NN
10     READ(8,444) G(I)  ! read data seria
      write(*,'(120F7.3)')(G(I),I=1,NN)
444    FORMAT(F7.3)

       FAX=G(1)
       DO 5 I=2,NN
       IF(G(I).GT.FAX) FAX=G(I)
 5     CONTINUE
       DO 6 I=1,NN 
	 G(I)=G(I)/FAX
 6     CONTINUE

       WRITE(*,222) 
222    FORMAT(3X,'GIVE MOVING AVERAGE VALUE (=1 or n)?')

C       READ(*,111)MA 
	MA=1
111    FORMAT(I2)
       WRITE(*,333)
333    FORMAT(3X,'HOU MANY SERIES?')

C       READ(*,111)NRM
	NRM=3
       WRITE(*,114)
114    FORMAT(3X,'GIVE MAX NO.OF FREQS^=15)77')

C       READ(*,*)JFM
	JFM=8
       JF2=2*JFM+2
       WRITE(*,115)
115    FORMAT(3X,'GIVE FREEDOM OF CHOICE^ MAX FREQS)?')

C       READ(*,*)JF
	JF=7
       SMA=0.0
       DO 7 I=1,MA
 7     SMA=SMA+G(I)
       SMA=SMA/MA
       GY(1)=SMA
       IX=1
       MHR=MA+1
       DO 8 I=MHR,NN
       IX=IX+1
       IX1=IX-1
       IMA=I-MA
       GY(IX)=GY(IX1)+(G(I)-G(IMA))/MA
 8     CONTINUE
       DO 9 I=1,IX 
	 G(I)=GY(I)
 9     CONTINUE
       CALL HARMAN(N,NP,NE,NN,PT,JF,JFM,NRM,0,1,JF2,NPT)
       STOP
       END
