CĿ
C        Name: CORN05                                                         
C                                                                             
C Description:  ᨢ COR(NN,NN) ୮ ५樨  ப     
C               ( 1 - COR(I,J)) / 2                                           
C                                                                             
C Copyright (C)  Gregory Ivakhnenko, 1990-1992. All Rights Reserved           
C

      subroutine CORN05 (M,N,MM,NN,X,XD,XS,COR)
      real     X(MM,NN), XD(MM,NN), COR(NN,NN), XS(NN)
      common /LCORR/ JCOR
      automatic

      do 10 K=1,N
         do 10 L=1,N
10       COR(K,L) = 0.                       ! Initializing
C --------------------------------------------------------------------------
      do 30 I=1,N
         S = 0.
            do 20 J= 1,M
20          S = S + X( J,I )
30       XS( I )= S / N                      ! Found average value
C --------------------------------------------------------------------------
      do 40 J=1,M
         do 40 I=1,N
40       XD( J,I ) = X( J,I ) - XS( I )      ! Centering array
C --------------------------------------------------------------------------
      do 60 K= 1,N
         do 60 L= K,N
         S  = 0.
         S1 = 0.
         S2 = 0.
         do 50 J= 1,M
            S  = S  + XD( J,L ) * XD( J,K )
            S1 = S1 + XD( J,L ) **2
50          S2 = S2 + XD( J,K ) **2
         if( S1*S2 .eq. 0.) then
             COR( K,L ) = 0.
         else
             COR( K,L ) = S / sqrt( S1 * S2 )   ! Found COR value
         endif

         COR( K,L ) = ( 1 - COR(K,L)) / 2       ! Calculate 1-COR/2
60       COR( L,K ) = COR(K,L)                  ! Symetria

      if( JCOR .eq. 1) then
          write (*,111)
          write (*,*) ' Pair correlation matrix :'
          call MATPRI ( N,N, NN,NN, COR )
      endif
      return
111   format(//,79('+'),/)
      end
