CĿ
C                            IiI FORTRAN Program            01/12/92 03:00pm  
C        Name: Analog_XY                                                      
C                                                                             
C Description: ⨢  ஢                  
C              ⮤ 㯯  㬥⮢   ()                    
C               ண  ᯮ ᮡ⨩ (権)                
C                                                                             
C Copyright (C) Nataly and Gregory Ivakhnenko, 1990-1991. All Rights Reserved 
C

      program  Analog_XY
      real
     +Y   [allocatable] (:,:), YP  [allocatable] (:,:),
     +XV  [allocatable] (:,:), X   [allocatable] (:,:),
     +XA  [allocatable] (:,:), XB  [allocatable] (:,:),
     +CL  [allocatable] (:,:), RAS [allocatable] (:,:),
     +RIY [allocatable] (:),   RAY [allocatable] (:),
     +SY  [allocatable] (:),   OC  [allocatable] (:),
     +CVJ [allocatable] (:),   CLX [allocatable] (:),
     +RSX [allocatable] (:),   XPR [allocatable] (:),
     +V   [allocatable] (:),   XN  [allocatable] (:)
      integer
     +IVM [allocatable] (:,:), IL [allocatable] (:),
     +IMX [allocatable] (:),   IN [allocatable] (:),
     +IPAR (3), KL

      logical*1    LA [allocatable] (:)
      character*80 D,G
      character*65 D_NAME

      common /LDAT/  JPRI
      common /LNORXX/JPRN
      common /LRAST/ JRAS
      common /LRAXV/ JRAXV
      common /LMAIN/ JP,JFM
      automatic
C==============================================================================
C       MM           - ᨬ쭮 ⢮ ६
C       MMY          - ᨬ쭮 ⢮ 㭪権
C       NN           - ᨬ쭮 ⢮ 祪
C       XV  (MM,NN1) - 室 ᨢ 㬥⮢
C       X   (MM,NN1) - ᨢ 㬥⮢  ⥪饣 ᠬ ६
C       Y   (MMY,NN) - 室 ᨢ 㭪権
C       YP  (MMY,NN1)- ᨢ ண 㭪権
C       XA  (MM,NN)  - ᨢ 饭 
C       XB  (MM,NN)  - ᨢ ⢨⥫ 祭 㬥⮢
C       CL  (JJFR,NN)- ᨢ ᮢ 樥⮢ 
C       RAS (NN,NN)  - ᨢ ﭨ  㭪権
C       RSX (MM)     -   祭 㬥⮢
C       CLX (MM)     -  ᨬ 祭 㬥⮢
C       RIY (MMY)    -   祭 㭪権
C       RAY (MMY)    -  ᨬ 祭 㭪権
C       SY  (MMY)    -  । 祭 㭪権
C       OC  (MMY)    -  業 ண 㭪権
C       CVJ (MM)     -  ਥ ண 㬥⮢
C       XPR (MM)     - ⥪騩  㬥⮢  ண
C       V   (NN)     -   ﭨ  ⥪饣  㬥⮢
C       XN  (NN)     - ᯮ⥫  ﭨ
C       IVM (JJFR,NN)- ᨢ  ᥤ-
C       IL  (MM)     -   ﭨ  ⥪饣
C       IMX (MM)     - ᯮ⥫  ᠬ ६
C       IN  (NN)     -  ஢ 祪  ࠭஢  ﭨ
C       IPAR(LL)     -  ࠬ஢  䠩 PARA
C       LA  (MM)     -  ᠬ ६
C       JJFR [=10]   - ᨬ쭮 ⢮ 
C       JFM          - ⢮ 
C       JFC          - ⨬쭮 ⢮ 
C       JMC          - ⨬쭮 ⢮ ६
C       JPRI         - 䫠  室  (ࠢ 0  1)
C       JPRN         - 䫠  ନ஢ ᨢ 室 
C       JRAS         - 䫠  ﭨ  㭪権
C       JRAXV        - 䫠  ﭨ  㬥⮢
C       JP           - 䫠  ஬ १⮢
C==============================================================================
      JJFR=10
      write (*,1111)
      write (*,999)
      write (*,2222)
C --------------------------------------------------------------------------
C            ࠬ஢  䠩 PARA
C --------------------------------------------------------------------------
      call DI_PARA (JJFR,IPAR)
C --------------------------------------------------------------------------
C            
C --------------------------------------------------------------------------
      write (*,'(/,14X,2A\)') '    䠩 ',
     +' DATAY ?  (Y/N) -> '
       read (*,'(A)') Q
      write (*,*)
C --------------------------------------------------------------------------
C              䠩 DATAY
C --------------------------------------------------------------------------
      if(Q.ne.'N'.and.Q.ne.'n') then
         open (unit=1,file='DATAY',status='OLD',mode='READ',err=99999)
            read (1,'(3X,A,/)') D
            read (1,'(A3,I3)') G,M
            read (1,'(A3,I3,/)') G,N
            if(M.le.0.or.N.le.1) then
               close (unit=1)
               write (*,444) M,N
               stop ' '
            endif

            allocate ( XV(M,N+1), XPR(M), IL(M), stat=MEMERR )
            if(MEMERR.ne.0)  stop ' Abort: Not enough storage!'
               do 30 I=1,N
30             read (1,*) J,(XV(J,I),J=1,M)
            read (1,'(3X,A)') G
            read (1,'(A4,I2)') G,MY
         close (unit=1)
         if(MY.le.0) then
            write (*,666) MY
            deallocate ( XV,XPR,IL, stat=IERR )
            if(IERR.ne.0) write (*,*) ' Warning: Deallocation error!'
            stop ' '
         endif

         allocate ( Y(MY,N), stat=MEMERR )
         if(MEMERR.ne.0)  stop ' Abort: Not enough storage!'
         MM=M
         MMY=MY
         NN=N
         NN1=N+1
         call DATINY (M,MY,N,MMY,MM,NN,NN1,XV,XPR,Y,IL)
      else
C --------------------------------------------------------------------------
C              ०  c   䠩 DATAY
C --------------------------------------------------------------------------
         call D1_DATAY (KL,D_NAME,M,MY,N)
         MM=M
         MMY=MY
         NN=N
         NN1=N+1
            allocate (XV(MM,NN1),XPR(MM),IL(MM),Y(MMY,NN),stat=MEMERR)
            if(MEMERR.ne.0) stop ' Abort: Not enough storage!'
         call D2_DATAY (KL,D_NAME,M,MY,N,MM,MMY,NN,NN1,Y,XV,XPR,IL)
      endif
C --------------------------------------------------------------------------
C           ।   ⠫ ᨢ  
C --------------------------------------------------------------------------
      allocate ( YP(MMY,NN1), X(MM,NN1), XA(MM,NN), XB(MM,NN),
     +           CL(JJFR,NN), RAS(NN,NN), RIY(MMY), RAY(MMY), SY(MMY),
     +           OC(MMY), CVJ(MM), CLX(MM), RSX(MM), V(NN), XN(NN),
     +           IVM(JJFR,NN), IMX(MM), IN(NN), LA(MM),
     +           stat=MEMERR )
      if(MEMERR.ne.0)  stop ' Abort: Not enough storage!'
C --------------------------------------------------------------------------
C        ᢮ 祭 䨪ࠬ  ࠬࠬ
C --------------------------------------------------------------------------
      if(JFM.ge.N)  then
         write (*,777) JFM,N,N-1
         JFM=N-1
      endif
      JPRN  = JP
      JRAS  = 0
      JRAXV = 0
      write (*,111) JPRI
      write (*,222) JP
      write (*,333) JFM
      write (*,888)
      read (*,*)
      I=M*N
      if(JP.eq.0.and.I.gt.40) write (*,'(13X,A,//)')
     +',  ...'
C --------------------------------------------------------------------------
C        맮 ᭮ 
C --------------------------------------------------------------------------
      call PATXYY (MY,M,N,JJFR,MMY,MM,NN,NN1,
     +Y,YP,XV,X,XA,XB,CL,RAS,RIY,RAY,SY,OC,CVJ,CLX,RSX,XPR,
     +V,XN,IVM,IL,IMX,IN,LA)
C --------------------------------------------------------------------------
C        ᢮ 
C --------------------------------------------------------------------------
      read (*,*)
      deallocate (Y,YP,XV,X,XA,XB,CL,RAS,RIY,RAY,SY,OC,CVJ,CLX,RSX,
     +            XPR,V,XN,IVM,IL,IMX,IN,LA, stat=IERR )
      if(IERR.ne.0) write (*,*) ' Warning: Deallocation error!'
      stop ' '

111   format (/,7X,'ࠬ ० ࠡ ⬠ :',/,
     +13X,'䨪  室 ',11X,
     +'JPRI = ',I2)
222   format (13X,'䨪  ஬',
     +' १⮢   JP = ',I2,)
333   format (13X,'ᨬ쭮 ⢮ ',16X,'JFM =',I3)
444   format (/,8X,'訡: ⢮ ६ 室 ',
     +'ᨢ M =',I2,/,16X,' 祪 N =',I2,'   ண ',
     +'( M > 0, N > 1 ) !',/)
666   format (/,8X,'訡: ⢮ 㭪権 MY =',I2,
     +'   ண  ( MY > 0 ) !',/)
777   format (/,8X,'।०: ⢮  JFM =',I3,
     +' ॢ蠥',/,15X,'⢮ 祪 N =',I3,
     +' !  ਭ JFM =',I3,'.'/)
888   format (/,1X,79(''),/)
999   format(4X,'',69X,'',
     +/,4X,'',16X,'    ',17X,'',
     +/,4X,'',5X,'⮤  㯯    㬥⮢  ()',
     +'    ண',4X,'',
     +/,4X,'',22X,'  ᯮ  ᮡ⨩',22X,'',
     +/,4X,'',69X,'',
     +/,4X,'',5X,' 2.16   ⠫  ਣ਩ 孥 (c)',
     +'   1990-92',4X,'')
1111  format (///,4X,'',
     +'ͻ')
2222  format (4X,'',
     +'ͼ')
99999 stop '*** 訡:   䠩 DATAY ***'
      end
