CĿ
C     Name:  Balan                                           06/15/93 01:00am 
C                                                                             
C     Description:  Evaluation of balance criterion.                          
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Balan ( Kl,NI, S, X, AA,SNor,B,C, CO, IAn )

      real        X( ML,N ),       AA( ML1,N )
      real*8      SNor( ML1,ML1 ), C( ML1,ML1 ),  B( ML1,ML1 ),
     +            CO  ( ML1 )

      integer     IAn( ML11 ), NI
      real*8      S, SS
      common /LSize/  ML,ML0,ML1,ML11,N,LAn, MV,MV1,MV2, Qmax
      automatic
C==============================================================================
C          X - 室 ᨢ 
C        IAn - ⥪騩 ᠬ
C         AA - ᨢ ᫮ ࠢ
C       SNor - ᨢ 樥⮢ ଠ ࠢ
C         CO -   樥⮢
C         Kl - 䫠 室 -   (KHAL)
C         MV - ⥪饥 祭 ᫠ ६  ᠬ
C          S - ⠭ 祭 
C==============================================================================
C           Calculate model for first subsample A
C**********************************************************************
      S = Qmax
      L = 0                                     ! Number of points in subsample
      do 20 I= 1,N,2                            ! Odd points
         L = L + 1
         AA( NI+2,L ) = X( ML0,I )               !  write function at right col.
         do 20 J= 1,NI                          ! Creating AA array
20          AA( J+1,L ) = X( IAn( J ),I )       !  by current variables ansamble

      call REG8 ( Kl, NI+1,NI+2, L, ML1, B,C,SNor,AA, CO )
      if ( Kl .ne. 0 ) return                   ! Model can't be calculated

!      do 30 I= 1,N
!         VN( I ) = CO( 1 )
!            do 30 J= 1,NI                                   ! Calculate model value in
!30          VN( I ) = VN( I ) + X( IAn( J ), I ) * CO( J+1 )! control point

	S = 0.
	do I= 2,N,2										! Test subsample B !
		S = S + ( X( ML0,I ) - 
     +		CO( 1 ) - sum( X( IAn(1:NI),I ) * CO(2:NI+1)) )**2
	end do
C**********************************************************************
C           Calculate model for second subsample B  and found criterion value
C**********************************************************************
      CO = 0.
	L  = 0                                    ! Number of points in subsample
      do 40 I= 2,N,2                            ! Even points
         L = L + 1
         AA( NI+2,L ) = X( ML0,I )              !  write function at right col.
         do 40 J= 1,NI                          ! Creating AA array
40          AA( J+1,L ) = X( IAn( J ),I )       !  by current variables ansamble

      call REG8 ( Kl, NI+1,NI+2, L, ML1, B,C,SNor,AA, CO )
      if ( Kl .ne. 0 ) return                   ! Model can't be calculated

!      S = 0.
!      do 60 I= 1,N
!         SS = CO( 1 )
!            do 50 J= 1,NI                             ! Calculate model value in
!50          SS = SS + X( IAn( J ), I ) * CO( J+1 )    ! control point
!
!60       S = S + (( VN( I ) - SS )** 2 )       ! Sum of criteria ( Ya - Yb )**2

	do I= 1,N,2								  ! Test subsample B !
		S = S + ( X( ML0,I ) - 
     +		CO( 1 ) - sum( X( IAn(1:NI),I ) * CO(2:NI+1)) )**2
	end do

      S = S / N                                 ! Average criterion value
      return
      end
