c*********************************************************************
C    HARMONICAL INDUCTIVE LEARNING ALGORITHM
C
C
C     N - NO.OF TRAINING SET POINTS
C     NP - NO.OF TEST SET POINTS
C     NE - NO.OF EXAMIN SET POINTS
C     PT - NO.OF PREDICTION POINTS
C     JFM - MAX NO.OF FREQUENCIES
C     JF - FREEDOM OF CHOICE
C     NRM - NO.OF SERIES IN HARMONICAL TREND
C     NN = N+NP+NE
C     NPT = NN+PT
C     G(NN) - DISCRETE SIGNAL DATA
C     APR(NPT) - HARMONICAL MODEL VALUES
C     MA - NO.OF LAG POINTS FOR SMOOTHING PROCEDURE(MOVING AVERAGE
C          VALUE). IF IT IS ONE, DATA REMAINS SAME
C
C*********************************************************************
C  MAIN PROGRAM
C
       INTEGER PT
       DIMENSION G(58),PA(4,58),PA1(4,58),AP(68),APR(68),YB(68),
     * TIN(4,8,1),IST(1),C(10,10)
		DO 10 1 I=1,58
1		G(I)=1.2*SIN(I * 0.34)-2.7*COS(I * 0.59)+1.1*COS(I* 0.43)
     *	-4.3*SIN(I*1.56)+2*COS(I*1.56)
	 PT=10
       
c       CALL HARMAN(N,NP,NE,NN,PT,JF,JFM,NRM,0,1,JF2,NPT)
	 CALL HARMAN(50,4,4,58,PT,4,4,1,1,0,5,10,68,
     *         	 G,YB,AP,APR,PA,PA1,TIN,IST,C)

       STOP
       END

 