c*********************************************************************
C    HARMONICAL INDUCTIVE LEARNING ALGORITHM
C
C
C     N - NO.OF TRAINING SET POINTS
C     NP - NO.OF TEST SET POINTS
C     NE - NO.OF EXAMIN SET POINTS
C     PT - NO.OF PREDICTION POINTS
C     JFM - MAX NO.OF FREQUENCIES
C     JF - FREEDOM OF CHOICE
C     NRM - NO.OF SERIES IN HARMONICAL TREND
C     NN = N+NP+NE
C     NPT = NN+PT
C     G(NN) - DISCRETE SIGNAL DATA
C     APR(NPT) - HARMONICAL MODEL VALUES
C     MA - NO.OF LAG POINTS FOR SMOOTHING PROCEDURE(MOVING AVERAGE
C          VALUE). IF IT IS ONE, DATA REMAINS SAME
C
C*********************************************************************
C  MAIN PROGRAM
C
       INTEGER PT
       DIMENSION GY(120)
       COMMON /AB/ G(120)
       OPEN(3,FILE='output.dat') 
	 OPEN(8,FILE='ts.dat')
       WRITE(3,4)
4      FORMAT(5X,' LAYERED    HARMONICAL ALGORITHM'/)
       WRITE(*,110) 
110    FORMAT(3X,'GIVE NO.OF TRAIN, TEST & EXAM PTS7')
       READ(*,*)N,NP,NE
       NN=N+NP+NE
       WRITE(*,112)
112    FORMAT(3X,'GIVE NO.OF PRED PTS77')
       READ(*,*)PT
       NPT=NN+PT
       READ(8,*)(G(I),I=1,NN)
       FAX=G(1)

       DO 5 I=2,NN
       IF(G(I).GT.FAX) FAX=G(I)
 5     CONTINUE
       DO 6 I=1,NN 
	 G(I)=G(I)/FAX
 6     CONTINUE
       WRITE(*,222) 
222    FORMAT(3X,'GIVE MOVING AVERAGE VALUE (=1 or n)7')
       READ(*,111)MA 
111    FORMAT(I2)
       WRITE(*,333)
333    FORMAT(3X,'HOU MANY SERIES?')
       READ(*,111)NRM
       WRITE(*,114)
114    FORMAT(3X,'GIVE MAX NO.OF FREQS^=15)77')
       READ(*,*)JFM
       JF2=2*JFM+2
       WRITE(*,115)
115    FORMAT(3X,'GIVE FREEDOM OF CHOICE^ MAX FREQS)77')
       READ(*,*)JF
       SMA=0.0
       DO 7 I=1,MA
 7     SMA=SMA+G(I)
       SMA=SMA/MA
       GY(1)=SMA
       IX=1
       MHR=MA+1
       DO 8 I=MHR,NN
       IX=IX+1
       IX1=IX-1
       IMA=I-MA
       GY(IX)=GY(IX1)+(G(I)-G(IMA))/MA
 8     CONTINUE
       DO 9 I=1,IX 
	 G(I)=GY(I)
 9     CONTINUE
       CALL HARMAN(N,NP,NE,NN,PT,JF,JFM,NRM,0,1,JF2,NPT)
       STOP
       END

 